/* Program using the PAR card and Imagemaster to apply an effect to video. 

By Don Cox, Dec 95. Copyright, not Public Domain.
 */
/* $VER: PARPseudoColor Dec 95 */

/*call open("STDERR","ram:tracePSC,"W")
trace r*/


if show('P','IM_Port') = 0 then do
    say "Can't find image processor's ARexx port!!!"; /* not running? */
    say "This script requires ImageMaster to run!";
    exit(20);
    end;

if ~show('L',"rexxsupport.library") then do
  if ~addlib('rexxsupport.library',0,-30,0) then do
    say 'We Have A Library Problem, Unable To Load "rexxsupport.library"';
    say 'Cannot operate this script without this library - sorry!';
    'finish';
    exit 10;
    end;
  end;


options results
call pragma('stack',20000);

address 'IM_Port'
'imtofront'; /* show user the IM screen */
'filerequest "DDR:" "" "" "Video file to process"'
PARanimfile = result
if PARanimfile = 'FR_CANCELLED' then do
    address 'IM_Port'
    'imtofront'
    exit 0
    end
PARanimfile = expandfilename(PARanimfile)
PARanimpath = gimmepath(PARanimfile)
parse var PARanimpath PARanimpath PARanimname
PARanimname = strip(PARanimname)

'filerequest "DDR:" "" "" "Final Video file"'
PARoutputfile = result
if PARoutputfile = 'FR_CANCELLED' then wayout("No output selected")
PARoutputfile = expandfilename(PARoutputfile)
PARoutputpath = gimmepath(PARoutputfile)
parse var PARoutputpath PARoutputpath PARoutputname
PARoutputname = strip(PARoutputname)

address DDR

file PARanimfile
if result = "" then wayout("Could not load video file")
frames
nframes = result
if nframes = 0 then wayout()


/* get PAR prefs (and restore them at exit) */

Mode
r_Mode=result
EMode
r_EMode=result
Filter
r_filter=result
Translate
r_Translate=result
Exporter
r_Exporter=result

/* Set up prefs */
Exporter IFF
EMode FRAME
Mode ANIM
Filter OFF
Translate ON

address 'IM_Port'

/* We can fade the effect in and out */
videofade = 0
'askboolean "Fade effect?" 0' 
videofade = result

'trenddraw "FadePercent" 1 '||nframes||' 0 100 100 "Fade Envelope"'


PARanimframe = right(firstframe, 4, 0) /* pad with zeros */
'imagepath 'titlepath
'imageext ""'


'entire'
/*'autoredraw 0'*/ /* OFF */
'autoactivate 0'

do i = 1 to nframes
    address 'IM_Port'
    call buffkill()
    'current'
    buffdata = result
    parse var buffdata bname ', ' bnum ', ' bx ', ' by ', ' btot ', ' bmem ', ' bparname ', ' bparnum
    if bname ~= '<none>' then 'killbuff' bnum /* clear ram for next video image */

    'imagepath 'PARanimpath
    'imageext ""'
    'loadasprimary '||'"'||PARanimname||"."||PARanimframe||'"'
    'trendget "FadePercent" '||f  /* f is frame number for this title */
    pc = result*2.55
    call blendset(pc)
    'entire'
    'pseudo'
    'current'
    buffdata = result
    parse var buffdata priname ', ' prinum ', ' stuff
    'save 'prinum '"'||PARoutputfile||'"'
    'undo'
    end


        PARanimframe = right(PARanimframe+1, 4, 0) /* set number for next frame */

        end
    end 
wayout("Done - now name new PAR anim")


wayout:
address 'IM_Port'
'autoredraw 1'  /* ON */
'autoactivate 1'

parse arg infomessage
if infomessage ~= "" then do
    address 'IM_Port'
    'message 'infomessage
    end
address DDR
TOFRONT
Mode r_Mode
EMode r_EMode
Filter r_filter
Translate r_Translate
Exporter r_Exporter
Done
exit 0
end

/* +++++++++++++++++++++++++++++++  +++++++++++++++++++++++++++++++++++++ */

/* gimmepath
 This takes the provided argument and sucks the path out of it, then returns that path to the caller, sans file name. */

gimmepath:
  parse arg fullnamegx;
    tempgx = reverse(fullnamegx);
    lengx = length(fullnamegx);   /* get length of string */
    slashdex = index(tempgx,'/'); /* first occurance of '/' from right */
    colondex = index(tempgx,':');  /* first occurance of ':' from right */
    seploc = 0; /* assumes current dir, no path supplied */
    if slashdex ~= 0 then do /* we assume we are in a DIR */
      seploc = (lengx - slashdex)+1;
      end;
    else do
      if colondex ~= 0 then do /* we assume we are on a device */
        seploc = (lengx - colondex)+1;
        end;
      end;
  gxname = substr(fullnamegx,seploc+1); /* if you ever need it */
  gxpath = left(fullnamegx,seploc)
  gxpath = gxpath" "gxname
  return(gxpath);


/* +++++++++++++++++++++++++++++++ ++++++++++++++++++++++++++++++++++++ */

/*
 * Since this script can't be expected to know where the CD of the user
 * is when this cmd is invoked, we have to check the path the user
 * provides - if it's not specified right from a root, then we have
 * to make it a complete specification from the root.
 */
expandfilename:
  parse arg jfile;
  if index(jfile,':') = 0 then do
    curdir = pragma(D);
    if right(curdir,1) ~= ':' then do
      if right(curdir,1) ~= '/' then do
        if curdir ~= '' then do
          curdir = curdir || '/';
          end;
        end;
      end;
    jfile = curdir||jfile;
    end;
  return(jfile);

/* +++++++++++++++++++++++++++++++++ ++++++++++++++++++++++++++++++++++ */

blendset:
parse arg bv
'setallblend 'bv
'setblend 1 255 'bv /* bug workaround - setallblend doesn't */
'setblend 2 255 'bv
'setblend 3 255 'bv
'setblend 4 255 'bv
return

/* +++++++++++++++++++++++++++++ +++++++++++++++++++++++++++++++++++++ */

buffkill: procedure
'current'
buffdata = result
parse var buffdata currentname ', ' currentnum ', ' stuff
'sbuffers'
buffdata = result
do until buffdata =""
    parse var buffdata bname ', 'bnum ', ' buffdata
    if bname ~= '<none>' then do
        'newcurrent 'bnum
        'killbuff' bnum /* general cleanout */
        end
    end
'newcurrent 'currentnum
'sbuffers' /* check */
buffdata = result
return

